`timescale 1ns / 1ps
//**********************************************************************
//  Project:  
//  File:  
//  Description:       
//  Author:           gowin
//  Target Devices:   
//  Timestamp:        2022/12/12
//----------------------------------------------------------------------
module testreg
(
///clk & rst
    rst_i,
    clk_i,

///apb bus    
    cfg_psel_i,
    cfg_pwrite_i,
    cfg_penable_i,
    cfg_paddr_i,///byte address
    cfg_pwdata_i,
    cfg_pready_o,
    cfg_prdata_o,
               
///    
    pll0_lock_i,      
    pll1_lock_i,      
    cmu_ok_i,         
    pma_rx_lock_i,    
    lane_align_link_i,
    lane_k_lock_i,    
    lane_stat_i,      
    
    loop_en_o,
    port_initialized_i,
    link_initialized_i,
    request_check_error_i,
    request_done_i,       
    
    srio_rx_req_raddr_o,    
    srio_rx_req_rd_data_i,  
    srio_rx_req_rd_last_i,  
    srio_rx_req_rd_idinfo_i,
    
    error_cnt_i,
    test_ok_i,  
    done_cnt_i, 
    test_done_i,
    srio_device_id_i,
    phy_tx_mce_o,       
    phy_tx_link_reset_o,
    force_reinit_o,
    ln_rst_o,
    ln_pcs_tx_rst_o,
    ln_pcs_rx_rst_o,
    test_start_o
  
);

//----------------------------------------------------------------------
//parameter
//----------------------------------------------------------------------

//----------------------------------------------------------------------
//port
//----------------------------------------------------------------------
///clk & rst
input                                       rst_i;
input                                       clk_i;

///apb bus    
input                                       cfg_psel_i;
input                                       cfg_pwrite_i;
input                                       cfg_penable_i;
input  [11:0]                               cfg_paddr_i;///byte address
input  [31:0]                               cfg_pwdata_i;
output                                      cfg_pready_o;
output reg [31:0]                           cfg_prdata_o/* synthesis preserve = 1 */;

///      
input                                       pll0_lock_i;      
input                                       pll1_lock_i;      
input [3:0]                                 cmu_ok_i;         
input [3:0]                                 pma_rx_lock_i;    
input [3:0]                                 lane_align_link_i;
input [3:0]                                 lane_k_lock_i;    
input  [12:0]                               lane_stat_i;      

output reg [1:0]                            loop_en_o/* synthesis preserve = 1 */;
input                                       port_initialized_i; 
input                                       link_initialized_i; 
input  [1:0]                                request_check_error_i;
input  [1:0]                                request_done_i;         

output reg [8:0]                            srio_rx_req_raddr_o/* synthesis preserve = 1 */;    
input  [63:0]                               srio_rx_req_rd_data_i;  
input                                       srio_rx_req_rd_last_i;  
input  [31:0]                               srio_rx_req_rd_idinfo_i;
input  [15:0]                               srio_device_id_i;
input  [15:0]                               error_cnt_i;
input                                       test_ok_i;  
input  [15:0]                               done_cnt_i; 
input                                       test_done_i;

output reg                                  phy_tx_mce_o/* synthesis preserve = 1 */;       
output reg                                  phy_tx_link_reset_o/* synthesis preserve = 1 */;
output reg                                  force_reinit_o/* synthesis preserve = 1 */;
output reg                                  ln_rst_o/* synthesis preserve = 1 */;
output reg                                  ln_pcs_tx_rst_o/* synthesis preserve = 1 */;
output reg                                  ln_pcs_rx_rst_o/* synthesis preserve = 1 */;
output reg                                  test_start_o/* synthesis preserve = 1 */;

//----------------------------------------------------------------------
//signal
//----------------------------------------------------------------------                  
reg [31:0]                                  test_reg/* synthesis preserve = 1 */;  
reg                                         pll0_lock/* synthesis preserve = 1 */;      
reg                                         pll1_lock/* synthesis preserve = 1 */;      
reg [3:0]                                   cmu_ok/* synthesis preserve = 1 */;         
reg [3:0]                                   pma_rx_lock/* synthesis preserve = 1 */;    
reg [3:0]                                   lane_align_link/* synthesis preserve = 1 */;
reg [3:0]                                   lane_k_lock/* synthesis preserve = 1 */;    
reg [12:0]                                  lane_stat/* synthesis preserve = 1 */;      
reg                                         port_initialized/* synthesis preserve = 1 */;
reg                                         link_initialized/* synthesis preserve = 1 */;
reg [1:0]                                   request_check_error/* synthesis preserve = 1 */;
reg [1:0]                                   request_done/* synthesis preserve = 1 */;  

reg [8:0]                                   rx_req_raddr/* synthesis preserve = 1 */;

reg                                         srio_rx_req_rd_last/* synthesis preserve = 1 */;  
reg [31:0]                                  srio_rx_req_rd_idinfo/* synthesis preserve = 1 */;
reg [63:0]                                  srio_rx_req_rd_data/* synthesis preserve = 1 */;  

reg [15:0]                                  srio_device_id_1d/* synthesis preserve = 1 */; 
reg [15:0]                                  srio_device_id_2d/* synthesis preserve = 1 */; 

reg [15:0]                                  error_cnt_1d/* synthesis syn_ramstyle = "registers" */; 
reg                                         test_ok_1d/* synthesis preserve = 1 */;   
reg [15:0]                                  done_cnt_1d/* synthesis syn_ramstyle = "registers" */;  
reg                                         test_done_1d/* synthesis preserve = 1 */;
reg [15:0]                                  error_cnt_2d/* synthesis preserve = 1 */; 
reg                                         test_ok_2d/* synthesis preserve = 1 */;   
reg [15:0]                                  done_cnt_2d/* synthesis preserve = 1 */;  
reg                                         test_done_2d/* synthesis preserve = 1 */; 

//----------------------------------------------------------------------
//process
//----------------------------------------------------------------------                                     
assign                                      cfg_pready_o      = cfg_penable_i;            

///APB WRITE
always @ (posedge clk_i) 
begin
    if(rst_i == 1'b1)
    begin       
        test_reg            <= 32'h5a5a5a5a;///8'h2;
        loop_en_o           <= 2'b00;
        test_start_o        <= 1'b0;
        ln_rst_o            <= 1'b0;
        ln_pcs_tx_rst_o     <= 1'b0;
        ln_pcs_rx_rst_o     <= 1'b0;
        rx_req_raddr        <= 9'd0;
        phy_tx_mce_o        <= 1'b0;
        phy_tx_link_reset_o <= 1'b0;
        force_reinit_o      <= 1'b0;
    end
    else 
    begin
        if ((cfg_psel_i == 1'b1) && (cfg_pwrite_i == 1'b1))
        begin
            case (cfg_paddr_i[8:2])///byte address to word address
                7'd0:
                begin
                    test_reg            <= cfg_pwdata_i[31:0] ;
                end                     
                7'd1:                   
                begin                   
                    loop_en_o           <= cfg_pwdata_i[1:0] ;
                end                     
                7'd4:                   
                begin                   
                    test_start_o        <= cfg_pwdata_i[0] ;
                end                     
                7'd5:                   
                begin                   
                    ln_rst_o            <= cfg_pwdata_i[0] ;
                    ln_pcs_tx_rst_o     <= cfg_pwdata_i[1] ;
                    ln_pcs_rx_rst_o     <= cfg_pwdata_i[2] ;
                end                     
                7'd7:                   
                begin                   
                    rx_req_raddr        <= cfg_pwdata_i[8:0] ;
                end 
                7'd12:
                begin
                    phy_tx_mce_o        <= cfg_pwdata_i[0] ;
                    phy_tx_link_reset_o <= cfg_pwdata_i[1] ;
                    force_reinit_o      <= cfg_pwdata_i[2] ;
                end 
                                                                                                                                    
                default: ;
            endcase
        end                                                  
    end
end



///APB READ
always @ (posedge clk_i) 
begin
    if(rst_i == 1'b1)
    begin
        cfg_prdata_o <= 32'b0  ;
    end
    else  
    begin
        if((cfg_psel_i == 1'b1) && (cfg_pwrite_i == 1'b0))
        begin
            case (cfg_paddr_i[8:2])///byte address to word address
                7'd0: 
                begin
                    cfg_prdata_o[31:0] <= test_reg;                    
                end
                7'd1: 
                begin
                    cfg_prdata_o[31:10] <= 22'd0;
                    cfg_prdata_o[9]     <= 1'b0;
                    cfg_prdata_o[8]     <= 1'b0;
                    cfg_prdata_o[7:2]   <= 6'd0;
                    cfg_prdata_o[1:0]   <= loop_en_o;
                end
                7'd2: 
                begin
                    cfg_prdata_o[31:20] <= 12'd0;
                    cfg_prdata_o[19:16] <= lane_k_lock;
                    cfg_prdata_o[15:12] <= lane_align_link;
                    cfg_prdata_o[11:8]  <= pma_rx_lock;
                    cfg_prdata_o[7:4]   <= cmu_ok;
                    cfg_prdata_o[3:2]   <= 2'd0;
                    cfg_prdata_o[1]     <= pll1_lock;
                    cfg_prdata_o[0]     <= pll0_lock;
                end
                7'd3: 
                begin
                    cfg_prdata_o[31:10] <= 22'd0;
                    cfg_prdata_o[9]     <= 1'b0;
                    cfg_prdata_o[8]     <= 1'b0;
                    cfg_prdata_o[7]     <= 1'b0;
                    cfg_prdata_o[6]     <= 1'b0;
                    cfg_prdata_o[5]     <= 1'b0;
                    cfg_prdata_o[4]     <= 1'b0;
                    cfg_prdata_o[3]     <= 1'b0;
                    cfg_prdata_o[2]     <= 1'b0;
                    cfg_prdata_o[1]     <= link_initialized;
                    cfg_prdata_o[0]     <= port_initialized;
                end
                7'd4: 
                begin
                    cfg_prdata_o[31:10] <= 22'd0;
                    cfg_prdata_o[9]     <= 1'b0;
                    cfg_prdata_o[8]     <= 1'b0;
                    cfg_prdata_o[7:1]   <= 7'd0;
                    cfg_prdata_o[0:0]   <= test_start_o;
                end
                7'd5: 
                begin
                    cfg_prdata_o[31:10] <= 22'd0;
                    cfg_prdata_o[9]     <= 1'b0;
                    cfg_prdata_o[8]     <= 1'b0;
                    cfg_prdata_o[7:3]   <= 5'd0;
                    cfg_prdata_o[2]     <= ln_pcs_rx_rst_o;
                    cfg_prdata_o[1]     <= ln_pcs_tx_rst_o;
                    cfg_prdata_o[0]     <= ln_rst_o;
                end
                7'd6: 
                begin
                    cfg_prdata_o[31:4]  <= 28'd0;
                    cfg_prdata_o[3:2]   <= request_check_error;
                    cfg_prdata_o[1:0]   <= request_done;
                end

                7'd7: 
                begin
                    cfg_prdata_o[31:9]  <= 23'd0;
                    cfg_prdata_o[8:0]   <= rx_req_raddr;
                end
                7'd8: 
                begin
                    cfg_prdata_o[31:1]  <= 31'd0;
                    cfg_prdata_o[0]     <= srio_rx_req_rd_last;
                end
                7'd9: 
                begin
                    cfg_prdata_o[31:0]  <= srio_rx_req_rd_idinfo;
                end
                7'd10: 
                begin
                    cfg_prdata_o[31:0]  <= srio_rx_req_rd_data[31:0];
                end
                7'd11: 
                begin
                    cfg_prdata_o[31:0]  <= srio_rx_req_rd_data[63:32];
                end
                7'd12: 
                begin
                    cfg_prdata_o[0]     <= phy_tx_mce_o;
                    cfg_prdata_o[1]     <= phy_tx_link_reset_o;
                    cfg_prdata_o[2]     <= force_reinit_o;
                end
                7'd13: 
                begin
                    cfg_prdata_o[15:0]  <= srio_device_id_1d;
                end
                7'd16: 
                begin
                    cfg_prdata_o[31:2]  <= 30'd0;
                    cfg_prdata_o[1]     <= test_ok_1d;
                    cfg_prdata_o[0]     <= test_done_1d;
                end
                7'd17: 
                begin
                    cfg_prdata_o[31:16] <= error_cnt_1d;
                    cfg_prdata_o[15:0]  <= done_cnt_1d;
                end     

               default: ;
            endcase
        end
    end
end

  
always @ (posedge clk_i) 
begin     
    pll0_lock             <= pll0_lock_i;                  
    pll1_lock             <= pll1_lock_i;                  
    cmu_ok                <= cmu_ok_i;                     
    pma_rx_lock           <= pma_rx_lock_i;                
    lane_align_link       <= lane_align_link_i;            
    lane_k_lock           <= lane_k_lock_i;                
    lane_stat             <= lane_stat_i;  
    port_initialized      <= port_initialized_i;
    link_initialized      <= link_initialized_i;
    request_check_error   <= request_check_error_i;
    request_done          <= request_done_i;
    srio_rx_req_raddr_o   <= rx_req_raddr;
    srio_rx_req_rd_last   <= srio_rx_req_rd_last_i;
    srio_rx_req_rd_idinfo <= srio_rx_req_rd_idinfo_i;
    srio_rx_req_rd_data   <= srio_rx_req_rd_data_i; 
    srio_device_id_1d     <= srio_device_id_i;    
    srio_device_id_2d     <= srio_device_id_1d;   
    error_cnt_1d          <= error_cnt_i;
    test_ok_1d            <= test_ok_i; 
    done_cnt_1d           <= done_cnt_i;    
    test_done_1d          <= test_done_i;    
    error_cnt_2d          <= error_cnt_1d;
    test_ok_2d            <= test_ok_1d; 
    done_cnt_2d           <= done_cnt_1d;    
    test_done_2d          <= test_done_1d;        
end


endmodule
