`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2023/05/06 12:51:37
// Design Name: 
// Module Name: srio_board
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module srio_board
(
    input           sys_clk_i, //50M
	input           resetn_i,///SW2
    input           sw_i,///SW1

    input           rx_i,
    output          tx_o,
    
    output [1:0]    sw_o,
    output [1:0]    test_o,
    output [3:0]    led_o      

);

//////////////////////////////////////////////////////////////////////////////////
localparam                              DEST_ID   = 16'hafaf;
localparam                              LNRST_DLY = 5; 
localparam                              TEST_MODE = 0;///0 single test, 1 continuous test

`include "./serdes/srio/temp/srio/srio_defines.vh"

//////////////////////////////////////////////////////////////////////////////////
//-------- CLK & RST Interface
wire                                    srio_clk/* synthesis syn_keep=1 */;
wire                                    clk_lock;
wire                                    srio_clk_lock;
wire                                    user_pcs_clk/* synthesis syn_keep=1 */;

wire                                    cfg_clk;
wire                                    cfg_rst;

wire                                    clk_15p625m;
wire                                    clk_31p25m;
wire                                    clk_62p5m;
wire                                    clk_125m;
wire                                    clk_78p125m;
wire                                    clk_156p25m;
wire                                    clk_39p0625m;
wire                                    clk_10m;

wire                                    srio_rst;              
wire                                    maint_cfg_rst;         
wire                                    async_cfg_rst_n;       
///wire                                    async_maints_cfg_rst_n;
reg [2:0]                               cfg_rst_srl;
///reg [2:0]                               maints_cfg_rst_srl;

//-------- user interface clock
wire                                    srio_ui_clk;
wire                                    srio_ui_rst;
           
//-------- user interface TX           
wire                                    tx_req_trac_valid/* synthesis syn_keep=1 */;
wire                                    tx_req_trac_ready/* synthesis syn_keep=1 */;
wire                                    tx_req_trac_last/* synthesis syn_keep=1 */;
wire[63:0]                              tx_req_trac_data/* synthesis syn_keep=1 */;
wire[`DEVICE_ID_W*2-1:0]                tx_req_trac_id_info/* synthesis syn_keep=1 */;
wire[31:0]                              tx_req_trac_idinfo_temp/* synthesis syn_keep=1 */;
                        
wire                                    tx_resp_trac_valid/* synthesis syn_keep=1 */;
wire                                    tx_resp_trac_ready/* synthesis syn_keep=1 */;
wire                                    tx_resp_trac_last/* synthesis syn_keep=1 */;
wire[63:0]                              tx_resp_trac_data/* synthesis syn_keep=1 */;
wire[`DEVICE_ID_W*2-1:0]                tx_resp_trac_id_info/* synthesis syn_keep=1 */;
wire[31:0]                              tx_resp_trac_idinfo_temp/* synthesis syn_keep=1 */;
                                            
//-------- user interface RX            
wire                                    rx_req_trac_ready/* synthesis syn_keep=1 */;
wire                                    rx_req_trac_valid/* synthesis syn_keep=1 */;
wire                                    rx_req_trac_last/* synthesis syn_keep=1 */;
wire[63:0]                              rx_req_trac_data/* synthesis syn_keep=1 */;
wire[`DEVICE_ID_W*2-1:0]                rx_req_trac_id_info/* synthesis syn_keep=1 */;
            
wire                                    rx_resp_trac_ready/* synthesis syn_keep=1 */;
wire                                    rx_resp_trac_valid/* synthesis syn_keep=1 */;
wire                                    rx_resp_trac_last/* synthesis syn_keep=1 */;
wire[63:0]                              rx_resp_trac_data/* synthesis syn_keep=1 */;
wire[`DEVICE_ID_W*2-1:0]                rx_resp_trac_id_info/* synthesis syn_keep=1 */;
            
wire                                    port_initialized/* synthesis syn_keep=1 */;
wire                                    link_initialized/* synthesis syn_keep=1 */;

//-------- debug
wire[1:0]                               request_autocheck_error/* synthesis syn_keep=1 */;
wire[1:0]                               request_done/* synthesis syn_keep=1 */;

//-------- CPU Debug interface
wire                                    cfg0_psel/* synthesis syn_keep=1 */;
wire                                    cfg0_pwrite/* synthesis syn_keep=1 */;
wire                                    cfg0_penable/* synthesis syn_keep=1 */;
wire [21:0]                             cfg0_paddr/* synthesis syn_keep=1 */;///byte address
wire [31:0]                             cfg0_pwdata/* synthesis syn_keep=1 */;
wire                                    cfg0_pready/* synthesis syn_keep=1 */;
wire [31:0]                             cfg0_prdata/* synthesis syn_keep=1 */;
                                       
wire                                    cfg1_psel/* synthesis syn_keep=1 */;
wire                                    cfg1_pwrite/* synthesis syn_keep=1 */;
wire                                    cfg1_penable/* synthesis syn_keep=1 */;
wire [21:0]                             cfg1_paddr/* synthesis syn_keep=1 */;///byte address
wire [31:0]                             cfg1_pwdata/* synthesis syn_keep=1 */;
wire                                    cfg1_pready/* synthesis syn_keep=1 */;
wire [31:0]                             cfg1_prdata/* synthesis syn_keep=1 */;

wire                                    cfg2_psel/* synthesis syn_keep=1 */;
wire                                    cfg2_pwrite/* synthesis syn_keep=1 */;
wire                                    cfg2_penable/* synthesis syn_keep=1 */;
wire [21:0]                             cfg2_paddr/* synthesis syn_keep=1 */;///byte address
wire [31:0]                             cfg2_pwdata/* synthesis syn_keep=1 */;
wire                                    cfg2_pready/* synthesis syn_keep=1 */;
wire [31:0]                             cfg2_prdata/* synthesis syn_keep=1 */;

wire                                    maints_cfg_sel/* synthesis syn_keep=1 */;  
wire                                    maints_cfg_wr/* synthesis syn_keep=1 */;   
wire                                    maints_cfg_ena/* synthesis syn_keep=1 */;  
wire [21:0]                             maints_cfg_addr/* synthesis syn_keep=1 */; 
wire [31:0]                             maints_cfg_wdata/* synthesis syn_keep=1 */;     
wire                                    maints_cfg_rdy/* synthesis syn_keep=1 */;  
wire [31:0]                             maints_cfg_rdata/* synthesis syn_keep=1 */;

///-------- FOR Test
wire                                    ln_rst;    
wire [1:0]                              loop_en;
wire                                    test_start/* synthesis syn_keep=1 */;
reg                                     test_start_1d/* synthesis syn_keep=1 */;
reg                                     test_start_2d/* synthesis syn_keep=1 */;

///-------- FOR LEDS
reg                                     port_initialized_1d;       
reg                                     port_initialized_2d;       
reg                                     link_initialized_1d;       
reg                                     link_initialized_2d;       
reg                                     request_autocheck_error_1d;
reg                                     request_autocheck_error_2d;
reg                                     request_done_1d;           
reg                                     request_done_2d;

//-------- User define serdes control
///wire                                    gtr12_rstn;
wire                                    gtr12_pcs_tx_rst;
wire                                    gtr12_pcs_rx_rst;
wire  [`LANE_WIDTH-1:0]                 gtr12_lnx_align_link;
wire  [`LANE_WIDTH-1:0]                 gtr12_lnx_k_lock;
`ifdef CPLL_SEL
wire  [`LANE_WIDTH-1:0]                 gtr12_cmu_ok;
`else
wire                                    gtr12_cmu_ok;
`endif
wire                                    gtr12_cmu_ck_ref;
wire  [`LANE_WIDTH-1:0]                 gtr12_lnx_pma_rx_lock;
wire                                    gtr12_tx_pcs_clk;
wire                                    gtr12_rx_pcs_clk;

wire  [15:0]                            srio_device_id/* synthesis syn_keep=1 */;
wire  [15:0]                            srio_dest_id/* synthesis syn_keep=1 */;
wire  [31:0]                            rx_resp_trac_idinfo_temp/* synthesis syn_keep=1 */;
wire  [31:0]                            rx_req_trac_idinfo_temp/* synthesis syn_keep=1 */;
    
wire  [8:0]                             srio_rx_req_raddr;
wire  [63:0]                            srio_rx_req_rd_data;  
wire                                    srio_rx_req_rd_last;  
wire  [31:0]                            srio_rx_req_rd_idinfo;

reg                                     sw_start_1d;                   
reg                                     sw_start_2d; 
reg                                     sw_start_3d;                  
reg                                     srio_link_initialized_1d;
reg                                     srio_link_initialized_2d;
reg                                     req_trac_test_done_1d;            
reg                                     req_trac_test_done_2d;     
reg                                     req_maint_trac_test_done_1d;
reg                                     req_maint_trac_test_done_2d;       
reg                                     test_req=0;
reg                                     test_trac_req=0;
reg [15:0]                              error_cnt=0;
reg [15:0]                              done_cnt=0;
reg [2:0]                               test_init_cnt=0;
reg [2:0]                               initialized_cnt;
reg                                     test_en_flag;

wire                                    phy_tx_mce;       
wire                                    phy_tx_link_reset;
wire                                    phy_rx_mce;       
wire                                    phy_rx_link_reset;
reg                                     phy_tx_link_reset_r;
reg                                     phy_tx_link_reset_1d;
reg                                     phy_tx_link_reset_2d;
wire                                    force_reinit;
reg                                     phy_tx_mce_1d;
reg                                     phy_tx_mce_2d;
reg                                     force_reinit_1d;
reg                                     force_reinit_2d;

reg                                     gtr12_rstn;
reg [7:0]                               fpcs_st_cnt=0;

wire [3:0]                              serdes_align_link/* synthesis syn_keep=1 */;
wire [3:0]                              serdes_k_lock/* synthesis syn_keep=1 */;
wire [3:0]                              serdes_pma_rx_lock/* synthesis syn_keep=1 */;
wire [3:0]                              serdes_pll_ok/* synthesis syn_keep=1 */;

reg                                     test_done/* synthesis preserve = 1 */;
reg                                     test_ok/* synthesis preserve = 1 */;
reg                                     led0_r/* synthesis preserve = 1 */;
reg                                     led1_r/* synthesis preserve = 1 */;
reg                                     led2_r/* synthesis preserve = 1 */;
reg                                     led3_r/* synthesis preserve = 1 */;
reg                                     test0_r/* synthesis preserve = 1 */;
reg                                     test1_r/* synthesis preserve = 1 */;
reg [21:0]                              maints_cfg_addr_1d/* synthesis preserve = 1 */;

//////////////////////////////////////////////////////////////////////////////////
///Signal Assignments
generate
if(`DEVICE_ID_W == 8) begin
    assign                                  srio_dest_id               = {8'd0,DEST_ID[7:0]};
    assign                                  tx_req_trac_id_info        = {tx_req_trac_idinfo_temp[23:16],tx_req_trac_idinfo_temp[7:0]};
    assign                                  tx_resp_trac_id_info       = {tx_resp_trac_idinfo_temp[23:16],tx_resp_trac_idinfo_temp[7:0]};   
    assign                                  rx_resp_trac_idinfo_temp   = {8'b0,rx_resp_trac_id_info[15:8],8'b0,rx_resp_trac_id_info[7:0]};
    assign                                  rx_req_trac_idinfo_temp    = {8'b0,rx_req_trac_id_info[15:8],8'b0,rx_req_trac_id_info[7:0]};
end
else begin
    assign                                  srio_dest_id               = DEST_ID[15:0];
    assign                                  tx_req_trac_id_info        = {tx_req_trac_idinfo_temp[31:16],tx_req_trac_idinfo_temp[15:0]};
    assign                                  tx_resp_trac_id_info       = {tx_resp_trac_idinfo_temp[31:16],tx_resp_trac_idinfo_temp[15:0]};   
    assign                                  rx_resp_trac_idinfo_temp   = {rx_resp_trac_id_info[31:16],rx_resp_trac_id_info[15:0]};
    assign                                  rx_req_trac_idinfo_temp    = {rx_req_trac_id_info[31:16],rx_req_trac_id_info[15:0]};
end
endgenerate

    assign                                  led_o[0:0]                 = led0_r;
    assign                                  led_o[1:1]                 = led1_r;
    assign                                  led_o[2:2]                 = led2_r;
    assign                                  led_o[3:3]                 = led3_r;
    assign                                  test_o[0]                  = test0_r;
    assign                                  test_o[1]                  = test1_r;
    assign                                  sw_o[0]                    = 1'b0;///gtr12_tx_pcs_clk;
    assign                                  sw_o[1]                    = 1'b0;///gtr12_cmu_ck_ref;
    
    assign                                  cfg_clk                    = clk_10m;
    assign                                  cfg_rst                    = cfg_rst_srl[2];
    assign                                  srio_rst                   = ~(clk_lock && gtr12_rstn);
    assign                                  maint_cfg_rst              = cfg_rst_srl[2];///maints_cfg_rst_srl[2];
    assign                                  async_cfg_rst_n            = clk_lock & srio_clk_lock;
///    assign                                  async_maints_cfg_rst_n     = srio_clk_lock & (~srio_rst);

generate 
    if(`LANE_WIDTH == 1) begin
        assign                              serdes_align_link          = {3'd0,gtr12_lnx_align_link};
        assign                              serdes_k_lock              = {3'd0,gtr12_lnx_k_lock};
        assign                              serdes_pma_rx_lock         = {3'd0,gtr12_lnx_pma_rx_lock};
        `ifdef CPLL_SEL                     
        assign                              serdes_pll_ok              = {3'd0,gtr12_cmu_ok};
        `else                               
        assign                              serdes_pll_ok              = {3'd0,gtr12_cmu_ok};
        `endif
    end
    else if(`LANE_WIDTH == 2) begin
        assign                              serdes_align_link          = {2'd0,gtr12_lnx_align_link};
        assign                              serdes_k_lock              = {2'd0,gtr12_lnx_k_lock};
        assign                              serdes_pma_rx_lock         = {2'd0,gtr12_lnx_pma_rx_lock};
        `ifdef CPLL_SEL                     
        assign                              serdes_pll_ok              = {2'd0,gtr12_cmu_ok};
        `else                               
        assign                              serdes_pll_ok              = {3'd0,gtr12_cmu_ok};
        `endif
    end
    else begin ///(LANE_WIDTH == 4)
        assign                              serdes_align_link          = gtr12_lnx_align_link;
        assign                              serdes_k_lock              = gtr12_lnx_k_lock;
        assign                              serdes_pma_rx_lock         = gtr12_lnx_pma_rx_lock;
        `ifdef CPLL_SEL                     
        assign                              serdes_pll_ok              = gtr12_cmu_ok;
        `else                               
        assign                              serdes_pll_ok              = {3'd0,gtr12_cmu_ok};
        `endif
    end
endgenerate  

///1.25G  1x 15.625M  64ns
///1.25G  2x 31.25M   32ns
///1.25G  4x 62.5M    16ns
`ifdef LINE_RATE_1P25G
    assign                                  user_pcs_clk               = clk_31p25m;
generate 
    if(`LANE_WIDTH == 1) begin
        assign                              srio_clk                   = clk_15p625m;
    end                                     
    else if(`LANE_WIDTH == 2) begin         
        assign                              srio_clk                   = clk_31p25m;
    end                                     
    else begin ///(LANE_WIDTH == 4)         
        assign                              srio_clk                   = clk_62p5m;
    end                                     
endgenerate                                 
`endif                                      
                                            
///2.5G   1x 31.25M   32ns                  
///2.5G   2x 62.5M    16ns                  
`ifdef LINE_RATE_2P5G                       
    assign                                  user_pcs_clk               = clk_62p5m;
generate                                    
    if(`LANE_WIDTH == 1) begin              
        assign                              srio_clk                   = clk_31p25m;
    end                                     
    else if(`LANE_WIDTH == 2) begin         
        assign                              srio_clk                   = clk_62p5m;
    end                                     
    else begin         
        assign                              srio_clk                   = clk_125m;
    end                                     
endgenerate                                 
`endif                                      
                                            
///3.125G 1x 39.0625M 25.6ns                
///3.125G 2x 78.125M  12.8ns                
`ifdef LINE_RATE_3P125G                     
    assign                                  user_pcs_clk               = clk_78p125m;
generate                                    
    if(`LANE_WIDTH == 1) begin              
        assign                              srio_clk                   = clk_39p0625m;
    end                                     
    else if(`LANE_WIDTH == 2) begin         
        assign                              srio_clk                   = clk_78p125m;
    end                                     
endgenerate                                 
`endif                                      
                                            
///5G     1x 62.5M    16ns                  
`ifdef LINE_RATE_5G                         
    assign                                  user_pcs_clk               = clk_125m;
generate                                    
    if(`LANE_WIDTH == 1) begin              
        assign                              srio_clk                   = clk_62p5m;
    end
    else begin              
        assign                              srio_clk                   = clk_125m;
    end
endgenerate    
`endif

/////////////////
always@(posedge cfg_clk or negedge resetn_i) begin
    if(~resetn_i) begin
        led0_r                      <= 1'd0;
        led1_r                      <= 1'd0;
        led2_r                      <= 1'd0;
        led3_r                      <= 1'd0;
        test0_r                     <= 1'd0;
        test1_r                     <= 1'd0;
    end
    else begin
        led0_r                      <= clk_lock & srio_clk_lock;
        led1_r                      <= port_initialized_2d & link_initialized_2d;
        led2_r                      <= test_done;
        led3_r                      <= test_ok;
        test0_r                     <= ^maints_cfg_addr_1d;
        test1_r                     <= maints_cfg_addr_1d[0] ^ maints_cfg_addr_1d[1] ^ maints_cfg_addr_1d[21];
    end
end

///reset
always @(posedge cfg_clk or negedge resetn_i) begin
    if(~resetn_i) 
        fpcs_st_cnt<=0;
    else if(ln_rst)
        fpcs_st_cnt<=0;    
    else 
        fpcs_st_cnt<=fpcs_st_cnt+1;
end

always @ (posedge cfg_clk or negedge resetn_i) begin
    if (~resetn_i)
        gtr12_rstn <= 0;
    else if(ln_rst)
        gtr12_rstn<=0;    
    else begin
        if(fpcs_st_cnt[LNRST_DLY]==1)
            gtr12_rstn<=1;
        else 
            gtr12_rstn <=gtr12_rstn;
    end
end

always@(posedge cfg_clk or negedge async_cfg_rst_n) begin
    if(~async_cfg_rst_n)
        cfg_rst_srl[2:0] <= 3'b111;
    else 
        cfg_rst_srl[2:0] <= {cfg_rst_srl[1:0],1'b0};
end

///always@(posedge cfg_clk or negedge async_maints_cfg_rst_n) begin
///    if(~async_maints_cfg_rst_n)
///        maints_cfg_rst_srl[2:0] <= 3'b111;
///    else 
///        maints_cfg_rst_srl[2:0] <= {maints_cfg_rst_srl[1:0],1'b0};
///end

always@(posedge cfg_clk) begin
    port_initialized_1d         <= port_initialized;
    port_initialized_2d         <= port_initialized_1d;
    link_initialized_1d         <= link_initialized;
    link_initialized_2d         <= link_initialized_1d;
    maints_cfg_addr_1d          <= maints_cfg_addr;
end

always @(posedge srio_ui_clk) begin
    test_start_1d               <= test_start;
    test_start_2d               <= test_start_1d;
    sw_start_1d                 <= ~sw_i;
    sw_start_2d                 <= sw_start_1d;
    sw_start_3d                 <= sw_start_2d;
    srio_link_initialized_1d    <= link_initialized;
    srio_link_initialized_2d    <= srio_link_initialized_1d;
    req_trac_test_done_1d       <= request_done[0];
    req_trac_test_done_2d       <= req_trac_test_done_1d;
    req_maint_trac_test_done_1d <= request_done[1];
    req_maint_trac_test_done_2d <= req_maint_trac_test_done_1d;
    phy_tx_link_reset_1d        <= phy_tx_link_reset;
    phy_tx_link_reset_2d        <= phy_tx_link_reset_1d;
    phy_tx_mce_1d               <= phy_tx_mce;
    phy_tx_mce_2d               <= phy_tx_mce_1d;
    force_reinit_1d             <= force_reinit;
    force_reinit_2d             <= force_reinit_1d;
    request_autocheck_error_1d  <= |request_autocheck_error;
    request_autocheck_error_2d  <= request_autocheck_error_1d;
    request_done_1d             <= &request_done;
    request_done_2d             <= request_done_1d;
end

///Initiate a test task
always @(posedge srio_ui_clk) begin
    if(srio_ui_rst) begin
        test_en_flag         <= 1'd0;
    end
    else if(test_start_1d & (~test_start_2d)) begin
        test_en_flag         <= 1'd1;
    end
    else if(sw_start_2d & (~sw_start_3d)) begin
        test_en_flag         <= 1'd1;
    end
end

always @(posedge srio_ui_clk) begin
    if(srio_ui_rst) begin
        test_init_cnt       <= 3'd0;
    end
    else if(test_start_1d & (~test_start_2d)) begin
        test_init_cnt            <= 3'd0;
    end
    else if(sw_start_2d & (~sw_start_3d)) begin
        test_init_cnt            <= 3'd0;
    end
    else if(!test_req & srio_link_initialized_2d & test_en_flag) begin
        test_init_cnt            <= test_init_cnt + 3'b1;
    end
end

always @(posedge srio_ui_clk) begin
    if(srio_ui_rst) begin
        test_req            <= 1'b0;
    end
    else if(test_init_cnt[2]) begin
        test_req            <= 1'b1;
    end
    else begin
        test_req            <= 1'b0;
    end
end

///Initiate I/O port transaction request, divided into single trigger mode and continuous trigger mode.
always @(posedge srio_ui_clk) begin
    if (srio_ui_rst) begin
        initialized_cnt <= 3'd0;
    end 
    else if (~test_req) begin
        initialized_cnt <= 3'd0;
    end 
    else if ((req_trac_test_done_2d) && (TEST_MODE == 1)) begin///TEST_MODE == 0 single test, TEST_MODE == 1 continuous test
        initialized_cnt <= 3'd0;
    end 
    else if (!test_trac_req && test_req && req_maint_trac_test_done_2d) begin
        initialized_cnt <= initialized_cnt + 3'b1;
    end 
end

always @(posedge srio_ui_clk) begin
    if(srio_ui_rst) begin
        test_trac_req            <= 1'b0;
    end
    else if(initialized_cnt[2]) begin
        test_trac_req            <= 1'b1;
    end
    else begin
        test_trac_req            <= 1'b0;
    end
end

///Test for errors
always @(posedge srio_ui_clk) begin
    if (test_init_cnt[2] == 1'b0) begin
        error_cnt <= 16'd0;
        test_ok   <= 1'b0;
    end 
    else if (request_done_1d && (!request_done_2d) && (request_autocheck_error_1d)) begin
        error_cnt <= error_cnt + 1'b1;
        test_ok   <= 1'b0;
    end 
    else if (request_done_1d && (!request_done_2d) && (!request_autocheck_error_1d)) begin
        error_cnt <= error_cnt;
        test_ok   <= 1'b1;
    end 
end

///Is the test complete
always @(posedge srio_ui_clk) begin
    if (test_init_cnt[2] == 1'b0) begin
        done_cnt   <= 16'd0;
        test_done  <= 1'b0;
    end 
    else if (request_done_1d && (!request_done_2d)) begin
        done_cnt   <= done_cnt + 1'b1;
        test_done  <= 1'b1;
    end 
end

///It is necessary to wait until the reset of the peer end is completed, and then release the link-reset control symbol
always @(posedge srio_ui_clk) begin
    if(srio_ui_rst) begin
        phy_tx_link_reset_r   <= 1'b0;    
    end
    else if(phy_tx_link_reset_1d & ~phy_tx_link_reset_2d) begin
        phy_tx_link_reset_r   <= 1'b1;
    end
    else if(port_initialized == 1'b0) begin
        phy_tx_link_reset_r   <= 1'b0;
    end
end

Gowin_PLL u_gowin_pll
(
    .lock                              ( clk_lock                         ), //output lock
    .clkout0                           ( clk_10m                          ), //output clkout0
    .clkin                             ( sys_clk_i                        ), //input clkin
    .reset                             ( ~resetn_i                        ) //input reset
);                                                                       
                                                                         
`ifdef LINE_RATE_1P25G                                                  
Gowin_Serdes_PLL_1p25g u_gowin_serdes_pll                                    
(                                                                        
    .lock                              ( srio_clk_lock                    ), //output lock
    .clkout0                           ( clk_15p625m                      ), //output clkout0
    .clkout1                           ( clk_31p25m                       ), //output clkout1
    .clkout2                           ( clk_62p5m                        ), //output clkout2
    .clkin                             ( gtr12_tx_pcs_clk                 ), //input clkin 31.25m
    .reset                             ( ~resetn_i                        ) //input reset
);                                                                       
`elsif LINE_RATE_2P5G                                                  
Gowin_Serdes_PLL_2p5g u_gowin_serdes_pll0                                   
(                                                                        
    .lock                              ( srio_clk_lock                    ), //output lock
    .clkout0                           ( clk_31p25m                       ), //output clkout0
    .clkout1                           ( clk_62p5m                        ), //output clkout1
    .clkout2                           ( clk_125m                         ), //output clkout2
    .clkin                             ( gtr12_tx_pcs_clk                 ), //input clkin 62.5m
    .reset                             ( ~resetn_i                        ) //input reset
);                                                                       
`elsif LINE_RATE_3P125G                                                  
Gowin_Serdes_PLL_3p125g u_gowin_serdes_pll                                    
(                                                                        
    .lock                              ( srio_clk_lock                    ), //output lock
    .clkout0                           ( clk_39p0625m                     ), //output clkout0
    .clkout1                           ( clk_78p125m                      ), //output clkout1
    .clkout2                           ( clk_156p25m                      ), //output clkout2
    .clkin                             ( gtr12_tx_pcs_clk                 ), //input clkin 78.125m
    .reset                             ( ~resetn_i                        ) //input reset
);                                                                       
`else  ///LINE_RATE_5G                                                            
Gowin_Serdes_PLL_5g u_gowin_serdes_pll                                      
(                                                                        
    .lock                              ( srio_clk_lock                    ), //output lock
    .clkout0                           ( clk_62p5m                        ), //output clkout0
    .clkout1                           ( clk_125m                         ), //output clkout1
    .clkin                             ( gtr12_tx_pcs_clk                 ), //input clkin 125m
    .reset                             ( ~resetn_i                        ) //input reset
);
`endif

///Debug Bus
Uart_to_Bus_Top u_uart_to_bus_top 
(
	.rst_n_i                           ( ~cfg_rst                         ),                        
	.clk_i                             ( cfg_clk                          ),                
                                                                         
	.apb0_addr_o                       ( cfg0_paddr                       ),  
	.apb0_sel_o                        ( cfg0_psel                        ),
	.apb0_ena_o                        ( cfg0_penable                     ),
	.apb0_wr_o                         ( cfg0_pwrite                      ),
	.apb0_rdata_i                      ( cfg0_prdata                      ),
	.apb0_wdata_o                      ( cfg0_pwdata                      ),
	.apb0_rdy_i                        ( cfg0_pready                      ),
	.apb0_strb_o                       (                                  ),
                                                                         
	.apb1_addr_o                       ( cfg1_paddr                       ),
	.apb1_sel_o                        ( cfg1_psel                        ),
	.apb1_ena_o                        ( cfg1_penable                     ),
	.apb1_wr_o                         ( cfg1_pwrite                      ),
	.apb1_rdata_i                      ( cfg1_prdata                      ),
	.apb1_wdata_o                      ( cfg1_pwdata                      ),
	.apb1_rdy_i                        ( cfg1_pready                      ),
	.apb1_strb_o                       (                                  ),
                                                                         
	.uart_rx_i                         ( rx_i                             ),
	.uart_tx_o                         ( tx_o                             ),
                                                                         
    .uart_rx_led_o                     (                                  ),
    .uart_tx_led_o                     (                                  )
);

testreg u_testreg 
(
///clk & rst
    .rst_i                             ( cfg_rst                          ),
    .clk_i                             ( cfg_clk                          ),
                                                                          
///cfg bus                                                                
    .cfg_psel_i                        ( cfg0_psel                        ),
    .cfg_pwrite_i                      ( cfg0_pwrite                      ),
    .cfg_penable_i                     ( cfg0_penable                     ),
    .cfg_paddr_i                       ( cfg0_paddr[11:0]                 ),///byte address
    .cfg_pwdata_i                      ( cfg0_pwdata                      ),
    .cfg_pready_o                      ( cfg0_pready                      ),
    .cfg_prdata_o                      ( cfg0_prdata                      ),
                                                                          
///                                                                       
    .pll0_lock_i                       ( clk_lock                         ),
    .pll1_lock_i                       ( srio_clk_lock                    ),
    .cmu_ok_i                          ( serdes_pll_ok                    ),         
    .pma_rx_lock_i                     ( serdes_pma_rx_lock               ),    
    .lane_align_link_i                 ( serdes_align_link                ),///lane_align_link       ),
    .lane_k_lock_i                     ( serdes_k_lock                    ),///lane_k_lock           ),  
    .lane_stat_i                       ( 'd0                              ),  
                                                                          
    .loop_en_o                         ( loop_en                          ),   
    .port_initialized_i                ( port_initialized                 ),
    .link_initialized_i                ( link_initialized                 ),
    .request_check_error_i             ( request_autocheck_error          ),
    .request_done_i                    ( request_done                     ),
                                                                          
    .ln_rst_o                          ( ln_rst                           ),
    .ln_pcs_tx_rst_o                   ( gtr12_pcs_tx_rst                 ),
    .ln_pcs_rx_rst_o                   ( gtr12_pcs_rx_rst                 ),
    .test_start_o                      ( test_start                       ),
    .error_cnt_i                       ( error_cnt                        ),
    .test_ok_i                         ( test_ok                          ),
    .done_cnt_i                        ( done_cnt                         ),
    .test_done_i                       ( test_done                        ),
                                                                          
    .phy_tx_mce_o                      ( phy_tx_mce                       ),
    .phy_tx_link_reset_o               ( phy_tx_link_reset                ),
    .force_reinit_o                    ( force_reinit                     ),
                                                                          
    .srio_device_id_i                  ( srio_device_id                   ),
                                                                          
    .srio_rx_req_raddr_o               ( srio_rx_req_raddr                ),
    .srio_rx_req_rd_data_i             ( srio_rx_req_rd_data              ),
    .srio_rx_req_rd_last_i             ( srio_rx_req_rd_last              ),
    .srio_rx_req_rd_idinfo_i           ( srio_rx_req_rd_idinfo            )
    
);

cfg_2to1 u_cfg_2to1
(
    .cfg_clk_i                         ( cfg_clk                          ),
    .cfg_rst_i                         ( cfg_rst                          ),
                                                                          
    .cfg0_sel_i                        ( cfg1_psel                        ),
    .cfg0_wr_i                         ( cfg1_pwrite                      ),
    .cfg0_ena_i                        ( cfg1_penable                     ),
    .cfg0_addr_i                       ( cfg1_paddr                       ),
    .cfg0_wdata_i                      ( cfg1_pwdata                      ),
    .cfg0_strb_i                       ( 4'hf                             ),
    .cfg0_rdy_o                        ( cfg1_pready                      ),
    .cfg0_rdata_o                      ( cfg1_prdata                      ),
    .cfg0_slverr_o                     (                                  ),
                                                                          
    .cfg1_sel_i                        ( cfg2_psel                        ),
    .cfg1_wr_i                         ( cfg2_pwrite                      ),
    .cfg1_ena_i                        ( cfg2_penable                     ),
    .cfg1_addr_i                       ( cfg2_paddr                       ),
    .cfg1_wdata_i                      ( cfg2_pwdata                      ),
    .cfg1_strb_i                       ( 4'hf                             ),
    .cfg1_rdy_o                        ( cfg2_pready                      ),
    .cfg1_rdata_o                      ( cfg2_prdata                      ),
    .cfg1_slverr_o                     (                                  ),
                                                                          
    .cfg_sel_o                         ( maints_cfg_sel                   ),
    .cfg_wr_o                          ( maints_cfg_wr                    ),
    .cfg_ena_o                         ( maints_cfg_ena                   ),
    .cfg_addr_o                        ( maints_cfg_addr                  ),
    .cfg_wdata_o                       ( maints_cfg_wdata                 ),
    .cfg_strb_o                        (                                  ),
    .cfg_rdy_i                         ( maints_cfg_rdy                   ),
    .cfg_rdata_i                       ( maints_cfg_rdata                 ),
    .cfg_slverr_i                      ( 1'b0                             )

);

Serdes_Top u_Serdes_Top
(
    // --------- Clock & Reset                                        
    .SRIO_Top_sys_rst_i                ( srio_rst                         ), //input SRIO_Top_sys_rst_i
    .SRIO_Top_srio_clk_i               ( srio_clk                         ), //input SRIO_Top_srio_clk_i
    .SRIO_Top_clk_lock_i               ( srio_clk_lock                    ), //input SRIO_Top_clk_lock_i
    .SRIO_Top_user_pcs_clk_i           ( user_pcs_clk                     ),
                                                                         
    .SRIO_Top_srio_ui_clk_o            ( srio_ui_clk                      ), //output SRIO_Top_srio_ui_clk_o
    .SRIO_Top_srio_ui_rst_o            ( srio_ui_rst                      ), //output SRIO_Top_srio_ui_rst_o
                                                                         
    .SRIO_Top_cfg_clk_i                ( cfg_clk                          ), //input SRIO_Top_cfg_clk_i
    .SRIO_Top_cfg_rst_i                ( cfg_rst                          ), //input SRIO_Top_cfg_rst_i

    // --------- user interface TX                                        
    .SRIO_Top_tx_req_trac_ready_o      ( tx_req_trac_ready                ), //output SRIO_Top_tx_req_trac_ready_o
    .SRIO_Top_tx_req_trac_valid_i      ( tx_req_trac_valid                ), //input SRIO_Top_tx_req_trac_valid_i
    .SRIO_Top_tx_req_trac_last_i       ( tx_req_trac_last                 ), //input SRIO_Top_tx_req_trac_last_i
    .SRIO_Top_tx_req_trac_data_i       ( tx_req_trac_data                 ), //input [63:0] SRIO_Top_tx_req_trac_data_i
    .SRIO_Top_tx_req_trac_id_info_i    ( tx_req_trac_id_info              ), //input [15:0] SRIO_Top_tx_req_trac_id_info_i
    
    .SRIO_Top_tx_resp_trac_ready_o     ( tx_resp_trac_ready               ), //output SRIO_Top_tx_resp_trac_ready_o
    .SRIO_Top_tx_resp_trac_valid_i     ( tx_resp_trac_valid               ), //input SRIO_Top_tx_resp_trac_valid_i
    .SRIO_Top_tx_resp_trac_last_i      ( tx_resp_trac_last                ), //input SRIO_Top_tx_resp_trac_last_i
    .SRIO_Top_tx_resp_trac_data_i      ( tx_resp_trac_data                ), //input [63:0] SRIO_Top_tx_resp_trac_data_i
    .SRIO_Top_tx_resp_trac_id_info_i   ( tx_resp_trac_id_info             ), //input [15:0] SRIO_Top_tx_resp_trac_id_info_i

    // --------- user interface RX                                            
    .SRIO_Top_rx_req_trac_ready_i      ( rx_req_trac_ready                ), //input SRIO_Top_rx_req_trac_ready_i
    .SRIO_Top_rx_req_trac_valid_o      ( rx_req_trac_valid                ), //output SRIO_Top_rx_req_trac_valid_o
    .SRIO_Top_rx_req_trac_last_o       ( rx_req_trac_last                 ), //output SRIO_Top_rx_req_trac_last_o
    .SRIO_Top_rx_req_trac_data_o       ( rx_req_trac_data                 ), //output [63:0] SRIO_Top_rx_req_trac_data_o
    .SRIO_Top_rx_req_trac_id_info_o    ( rx_req_trac_id_info              ), //output [15:0] SRIO_Top_rx_req_trac_id_info_o

    .SRIO_Top_rx_resp_trac_ready_i     ( rx_resp_trac_ready               ), //input SRIO_Top_rx_resp_trac_ready_i    
    .SRIO_Top_rx_resp_trac_valid_o     ( rx_resp_trac_valid               ), //output SRIO_Top_rx_resp_trac_valid_o
    .SRIO_Top_rx_resp_trac_last_o      ( rx_resp_trac_last                ), //output SRIO_Top_rx_resp_trac_last_o
    .SRIO_Top_rx_resp_trac_data_o      ( rx_resp_trac_data                ), //output [63:0] SRIO_Top_rx_resp_trac_data_o
    .SRIO_Top_rx_resp_trac_id_info_o   ( rx_resp_trac_id_info             ), //output [15:0] SRIO_Top_rx_resp_trac_id_info_o

    // --------- PHY control signals                                      
    .SRIO_Top_force_reinit_i           ( force_reinit_2d                  ), //input SRIO_Top_force_reinit_i
    .SRIO_Top_phy_tx_mce_i             ( phy_tx_mce_2d                    ), //input SRIO_Top_phy_tx_mce_i
    .SRIO_Top_phy_tx_link_reset_i      ( phy_tx_link_reset_r              ), //input SRIO_Top_phy_tx_link_reset_i
                                                                          
    //-------- PHY Informational signals                                               
    .SRIO_Top_port_initialized_o       ( port_initialized                 ), //output SRIO_Top_port_initialized_o
    .SRIO_Top_link_initialized_o       ( link_initialized                 ), //output SRIO_Top_link_initialized_o
    
    // --------- core debug signals                                       
    .SRIO_Top_phy_rx_mce_o             ( phy_rx_mce                       ), //output SRIO_Top_phy_rx_mce_o
    .SRIO_Top_phy_rx_link_reset_o      ( phy_rx_link_reset                ), //output SRIO_Top_phy_rx_link_reset_o
    .SRIO_Top_port_error_o             (                                  ), //output SRIO_Top_port_error_o
    .SRIO_Top_port_timeout_o           (                                  ), //output [23:0] SRIO_Top_port_timeout_o
    .SRIO_Top_srio_host_o              (                                  ), //output SRIO_Top_srio_host_o
    .SRIO_Top_master_enable_o          (                                  ), //output SRIO_Top_master_enable_o
    .SRIO_Top_port_decode_error_o      (                                  ), //output SRIO_Top_port_decode_error_o
    .SRIO_Top_device_id_o              ( srio_device_id                   ), //output [15:0] SRIO_Top_device_id_o
    .SRIO_Top_debug_info_o             (                                  ), //output [31:0] SRIO_Top_debug_info_o
    .SRIO_Top_rxbuf_rewind_o           (                                  ), //output SRIO_Top_rxbuf_rewind_o
    .SRIO_Top_txbuf_rewind_o           (                                  ), //output SRIO_Top_txbuf_rewind_o

    // --------- Maintenance Bus                                              
    .SRIO_Top_cfg_sel_i                ( maints_cfg_sel                   ), //input SRIO_Top_cfg_sel_i
    .SRIO_Top_cfg_wr_i                 ( maints_cfg_wr                    ), //input SRIO_Top_cfg_wr_i
    .SRIO_Top_cfg_ena_i                ( maints_cfg_ena                   ), //input SRIO_Top_cfg_ena_i
    .SRIO_Top_cfg_addr_i               ( maints_cfg_addr                  ), //input [21:0] SRIO_Top_cfg_addr_i
    .SRIO_Top_cfg_wdata_i              ( maints_cfg_wdata                 ), //input [31:0] SRIO_Top_cfg_wdata_i
    .SRIO_Top_cfg_strb_i               ( 4'hf                             ), //input [3:0] SRIO_Top_cfg_strb_i
    .SRIO_Top_cfg_rdy_o                ( maints_cfg_rdy                   ), //output SRIO_Top_cfg_rdy_o
    .SRIO_Top_cfg_rdata_o              ( maints_cfg_rdata                 ), //output [31:0] SRIO_Top_cfg_rdata_o
    .SRIO_Top_cfg_slverr_o             (                                  ), //output SRIO_Top_cfg_slverr_o
    
    .SRIO_Top_maintenance_interrupt_o  (                                  ), //output SRIO_Top_maintenance_interrupt_o
    .SRIO_Top_maintenance_timeout_o    (                                  ), //output SRIO_Top_maintenance_timeout_o
    
    //-------- User define serdes control                                     
    .SRIO_Top_gtr12_align_link_o       ( gtr12_lnx_align_link             ), //output SRIO_Top_gtr12_align_link_o
    .SRIO_Top_gtr12_k_lock_o           ( gtr12_lnx_k_lock                 ), //output SRIO_Top_gtr12_k_lock_o
    .SRIO_Top_gtr12_pma_rx_lock_o      ( gtr12_lnx_pma_rx_lock            ), //output SRIO_Top_gtr12_pma_rx_lock_o
    .SRIO_Top_gtr12_pll_ok_o           ( gtr12_cmu_ok                     ), //output SRIO_Top_gtr12_pll_ok_o
    .SRIO_Top_gtr12_pll_ck_ref_o       ( gtr12_cmu_ck_ref                 ), //output SRIO_Top_gtr12_pll_ck_ref_o
    .SRIO_Top_gtr12_rx_fifo_rdusewd_o  (                                  ), //output [4:0] SRIO_Top_gtr12_rx_fifo_rdusewd_o
    .SRIO_Top_gtr12_tx_fifo_wrusewd_o  (                                  ), //output [4:0] SRIO_Top_gtr12_tx_fifo_wrusewd_o
    .SRIO_Top_gtr12_rstn_i             ( gtr12_rstn                       ), //input SRIO_Top_gtr12_rstn_i
    .SRIO_Top_gtr12_pcs_tx_rst_i       ( gtr12_pcs_tx_rst                 ), //input SRIO_Top_gtr12_pcs_tx_rst_i
    .SRIO_Top_gtr12_pcs_rx_rst_i       ( gtr12_pcs_rx_rst                 ), //input SRIO_Top_gtr12_pcs_rx_rst_i
    .SRIO_Top_gtr12_tx_pcs_clk_o       ( gtr12_tx_pcs_clk                 ),
    .SRIO_Top_gtr12_rx_pcs_clk_o       (                                  )
);

gowin_srio_maints u_gowin_srio_maints 
(
    .clk_i                             ( cfg_clk                          ),
    .rst_i                             ( cfg_rst                          ),
                                                                         
    .cfg_sel_o                         ( cfg2_psel                        ),
    .cfg_wr_o                          ( cfg2_pwrite                      ),
    .cfg_ena_o                         ( cfg2_penable                     ),
    .cfg_addr_o                        ( cfg2_paddr                       ),
    .cfg_wdata_o                       ( cfg2_pwdata                      ),
    .cfg_rdy_i                         ( cfg2_pready                      ),
    .cfg_rdata_i                       ( cfg2_prdata                      ),
                                      
    .srio_trac_start_i                 ( test_req                         ),
    .maint_done_o                      ( request_done[1]                  ),
    .maint_autocheck_error_o           ( request_autocheck_error[1]       )
);

//Send request transactions, receive response transactions
gowin_srio_request_gen u0_srio_request_gen 
(
    .clk_i                             ( srio_ui_clk                      ),
    .rst_i                             ( srio_ui_rst                      ),
                                                                         
    .deviceid_i                        ( srio_device_id                   ),
    .dest_id_i                         ( srio_dest_id                     ),
                                       
    .tx_req_tvalid_o                   ( tx_req_trac_valid                ),
    .tx_req_tready_i                   ( tx_req_trac_ready                ),
    .tx_req_tlast_o                    ( tx_req_trac_last                 ),
    .tx_req_tdata_o                    ( tx_req_trac_data                 ),
    .tx_req_tidinfo_o                  ( tx_req_trac_idinfo_temp          ),
                                                                       
    .rx_resp_tvalid_i                  ( rx_resp_trac_valid               ),
    .rx_resp_tready_o                  ( rx_resp_trac_ready               ),
    .rx_resp_tlast_i                   ( rx_resp_trac_last                ),
    .rx_resp_tdata_i                   ( rx_resp_trac_data                ),
    .rx_resp_tidinfo_i                 ( rx_resp_trac_idinfo_temp         ),
                                       
    .srio_trac_start_i                 ( test_trac_req                    ),
                                       
    .request_autocheck_error_o         ( request_autocheck_error[0]       ),
    .msg_autocheck_error_o             (                                  ),
    .request_done_o                    ( request_done[0]                  )
);


//Receive request transactions and send back response transactions
gowin_srio_response_gen u0_srio_response_gen 
(
    .clk_i                             ( srio_ui_clk                      ),
    .rst_i                             ( srio_ui_rst                      ),
                                                                          
    .deviceid_i                        ( srio_device_id                   ),
    .source_id_i                       ( 16'b0                            ),
                                                                          
    .srio_trac_start_i                 ( test_trac_req                    ),
                                                                          
    .srio_rx_req_raddr_i               ( srio_rx_req_raddr                ),
    .srio_rx_req_rd_data_o             ( srio_rx_req_rd_data              ),
    .srio_rx_req_rd_last_o             ( srio_rx_req_rd_last              ),
    .srio_rx_req_rd_idinfo_o           ( srio_rx_req_rd_idinfo            ),
                                                                          
    .tx_resp_trac_valid_o              ( tx_resp_trac_valid               ),
    .tx_resp_trac_ready_i              ( tx_resp_trac_ready               ),
    .tx_resp_trac_last_o               ( tx_resp_trac_last                ),
    .tx_resp_trac_data_o               ( tx_resp_trac_data                ),
    .tx_resp_trac_idinfo_o             ( tx_resp_trac_idinfo_temp         ),
                                                                          
    .rx_req_trac_valid_i               ( rx_req_trac_valid                ),
    .rx_req_trac_ready_o               ( rx_req_trac_ready                ),
    .rx_req_trac_last_i                ( rx_req_trac_last                 ),
    .rx_req_trac_data_i                ( rx_req_trac_data                 ),
    .rx_req_trac_idinfo_i              ( rx_req_trac_idinfo_temp          )
);



endmodule 
